; The just-queue header conversion, applied to any messages sent when
; V-MailServer simply queues a message to later processing.  This happens
; when the "-q" parameter is used, or if there is not enough free disk space
; available
;
; This particular conversion file adds a few headers, and updates the
; Reply-To: header to refer to the mail server address, instead of
; the sending address.  It also strips unnecessary 'junk' headers from
; the original.
;
; V-MailServer 2.0 header processing passes almost all headers from the
; original message to the output.  Any unwanted headers must be
; specifically removed.
;
;
; Remove or change these if you don't want them
;
UPDATE Reply-to: %InsServer-Name%@%InsNode%
UPDATE Precedence: bulk
;
;
; Strip the junk
;
STRIP Organization:
STRIP Received:
STRIP CC:
STRIP BCC:
STRIP Lines:
strip via:
STRIP x-*
strip content-*
strip MIME-*
strip Return-*
STRIP Errors-*
;
;
; Order the headers.  Any not listed will be added after the ordered headers
;
ORDER From
ORDER Received:
ORDER Date:
ORDER From:
ORDER Subject:
ORDER Sender:
ORDER To:
ORDER Cc:
ORDER Message-ID:
ORDER Reply-To:
ORDER Organization:
ORDER In-Reply-To:
ORDER Precedence:
