.se Support Files
.vm 1
.vi 3
.rl 2
.da 07 May, 1993
.ss fsuucp.cfg configuration file ([basedir]\fsuucp.cfg) 
.sa escape
 
This file controls execution of FSUUCP. Lines consist of a control variable
and a value, seperated by whitespace (space or tab). This file will be 
created and set up by the installer.  After creating this file, the 
installer will place it in the base directory, along with the rest of the 
executables.

YOU MUST HAVE AN ENVIRONMENT VARIABLE, "FSUUCP," WHICH CONTAINS THE
DIRECTORY WHICH CONTAINS THIS FILE.

Following is a list of the fields in the FSUUCP.CFG file. Most are
mandatory, and some are completed by the installer. They all may,
of course, be changed at any time.

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: sysname

Use: The full domainized name of your site. If you do not have a domain name, 
     the psuedo-domain .UUCP may be used, though it is discouraged, as most
     mailers will not understand it. It is highly recommended that you
     obtain a domain name. The .us domain set is free for the asking.

Example: sysname vogonsys.space.big.com
         sysname vogonsys.UUCP

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: logname

Use: The standard UUCP site name. This is the name that other machines 
     recognize your machine by.

Example: logname vogonsys

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: username

Use: The name of the user currently using the FSUUCP session. This determines 
     which mailbox to use, as well as which return paths are returned by mail 
     and news. Note that the value of the environment variable USER will 
     override this setting.

Example: user zaphod

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: fullname

Use: The string that is printed in both mail and news headers to identify a 
     user. Note that the value of the environment variable NAME will override 
     this setting.

Example: name Zaphod Beebelbrox

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: spool

Use: This is the base path for the spool directory. The spool directory holds
     the data and control files for mail and news that are waiting for
     transfer, as well as incoming data. It is recommended that the spool
     directory be located on a disk with plenty of space and decent response
     time.

Example: spool c:\fsuucp\spool

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: logfile

Use: This is the name for the UUCP logging file. Note that this field
     contains a complete file name, and not just a directory as in other
     fields. FSUUCP generates log files that are even uglier than UNIX(tm) 
     log files, but there is useful information in them for debugging purposes 
     and feed testing. You will want to watch the size of this file and prune 
     it occasionally.

Example: logfile c:\fsuucp\spool\uucp\logfile

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: organization

Use: This is the organization field which is printed in Usenet message headers

Example: organization Dr. Ho's Secret Laboratory and Daycare Centre

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: smarthost

Use: This is a valid UUCP bang-path to your nearest or most trusted smarthost.
     At this time, FSUUCP does not support domainized mailing by itself. If
     a mail path is generated that FSUUCP does not understand, it will punt
     the message off to this site, hoping it can make sense of it. Be sure 
     that the first name in the smarthost field is a system to which you 
     connect directly, and that it is mentioned in your SYSTEMS file.

Example: smarthost foo!bar!ucbvax

In this example, mail to "spock@enterprise.ufp.com" would be mailed as
"foo!bar!ucbvax!spock@enterprise.ufp.com", parsing from left to right.
(That is, it would be sent to "foo").

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: libdir

Use: This is the base path for the LIB directory. Within LIB are the control
     directories for UUCP and NEWS.

Example: libdir c:\fsuucp\lib

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: home

Use: This is the directory under which each user will have a home directory
     for storing a mailrc, sig, and newsrc file, as well as any system
     generated files specific to the user.

Example: home c:\fsuucp\home

NOTE: There has been confusion as to where user directories must be created. 
      The answer is under home, and only under home. You do not need to create 
      user directories in spool/mail. Doing so will, in fact, prohibit mail 
      from being delivered.

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: pubdir

Use: This is the path name for the directory which holds all files that are
     neither mail nor news.  This path is being implemented and reserved 
     for future use.

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: news

Use: This is the base path for the Usenet news directory. All newsgroup
     storage areas are based off of this path. The installer will also create 
     [news]\outgoing, for outgoing batch files.

Example: news c:\fsuucp\news

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: port

Use: This is the COM port to use. 1 is equivilant to COM1, 2 is COM2, etc.

Example: port 1

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: modem

Use: This is a filename, which contains modem configuration information.
     See the help file on MODEM for information about the internals of
     the modem configuration file.

Example: modem c:\fsuucp\modems\telebit.mdm

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: editor

Use: This is the switch for determining which editor to use. FSUUCP has an
     internal line editor, or allows you to specify your own. If you
     specify the line editor, you may still enter the visual editor with
     the proper escape code from within the line editor.

Example: editor line
Example: editor visual

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: visual

Use: This specifies an executable file name for visual editing. This file
     will be called if the EDITOR field is set to "visual," or you shell
     to a visual editor from within the line editor. The editor specified
     must be able to accept a file name as a sole argument, and not
     change the name of the final edited file.

Example: visual c:\fsuucp\bin\vi.exe

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: ramdisk

Use: If this optional field is placed in the fsuucp.cfg file, then all
     temporary storage will use the root directory of the drive specified.
     If no ramdisk is used, then temporary storage will use the path
     [spool]\uucp\tmp for all temporary files.

Example: ramdisk e

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: serveralias

Use: This optional field allows a remote machine to store files with
     server-dependent drive specifications in them. This is used by
     batcher.exe to correctly access news articles for batching.
     For example, if a network is running such that the remote machine 
     references the server's c: drive as f:, this field allows batcher to 
     run using the correct reference (c:).

     In this example, any references in a batch file in [news]/outgoing
     for any drive letter will be changed to c. This unconditional
     mapping allows multiple workstations to map the server's news spool
     to any letter, and allow the server to correctly access the articles.

Example : serveralias c

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: autosig

Use: This field controls the status of the automatic appending of 
     signature files to mail messages.  The default setting is always
     off. If you set it on, your signature ([home]\[user]\sig) will be
     appended to your outgoing mail messages.

     Signatures are automatically appended to news articles if a sig file
     exsts.

Example: autosig on

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Timeouts
  --------

    FSUUCP now supports 3 levels of timeouts in UUCICO.

    Field: tcd  - Timeout waiting for carrier from remote site

      For multiprotocol modems, like Telebits, you may have to set
      this pretty high, sometimes even as high as 90 seconds. Make 
      sure that your modem register controlling how long the modem
      waits for carrier is at least as long as this variable.

    Field: tlogin - Timeout while executing login script from SYSTEMS file

      On the average, 15 to 20 seconds is a good value here.

    Field: tdata  - Timeout while executing protocol transfer

      Since UUCICO will retry up to 10 times on bad data, 5 to 10
      seconds is a good average here. Your remote site may be slower
      or faster.

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Field: attribution

Use: This field allows you to create the format for the "attribution"
     line in news messages using the percent escape codes. See the manual
     page ESCAPE for a list of valid % codes.

Example: attribution In article %i, %f writes:
