unit rusnglob;

{

rusnglob.pas - constants, types, and global variables for rusnews

}

{$I rusn-def.pas}

interface

{$ifdef mouse}

uses mouse;

{$endif}

const

  newsreadername='rusnews';
  newsreaderversion='v1.06/UUPC';

{$ifdef tiny}
  maxarts=60;
  maxkills=50;
  maxlpp=25;
  maxcols=80;
  maxjoined=120;
{$else}
  maxarts=400;
  maxkills=150;
  maxlpp=50;
  maxcols=132;
  maxjoined=200;
{$endif}

  minlpp=8;
  mincols=32;

  eightbitclean=true;

  selheaderlines=1;
  headerbufsize=6144;
  headertlsize=256;

{$ifndef mouse}
  hasmouse=false;
{$endif}

type
  subjstringt=string[70];
  fnstringt=string[14];
  datet=longint;  {year * 16384 + month * 1024 + dayofmonth * 32 + gmthour}
  fromstringt=string[20];
  groupstringt=string[40];
  killstringt=string[75];
  fnarray=array[1..maxarts] of fnstringt;
  fromarray=array[1..maxarts] of fromstringt;
  datearray=array[1..maxarts] of datet;
  headerbuft=array[1..headerbufsize] of char;
  headerlinet=record
      first: char;
      offset: integer;
    end;
  headertrackedlinest=array[1..headertlsize] of headerlinet;
  killsarr=array[1..maxkills] of killstringt;
  killsarrp=^killsarr;
  hashedt=array[1..2] of word;
  hashedarr=array[1..maxarts] of hashedt;

{$ifdef mouse}
  mevent=record
           event, btnstatus, horiz, vert: word;
         end;
{$endif}

var
  oldfilemode: byte;
  basedir: string;
  userid: string;
  shadow: integer;
  numarts: integer;
  numjoined: integer;

{high nybble of indents used for auto-selected articles etc.}

  indents: array[1..maxarts] of byte;
  sizeink: array[1..maxarts] of byte;
  basesubjs: array[1..maxarts] of subjstringt;
  joinedgroups: array[1..maxjoined] of groupstringt;
  filenamesp: ^fnarray;
  fromsp: ^fromarray;
  datesp: ^datearray;
  hmessageidsp: ^hashedarr;
  hreferencesp: array[1..4] of ^hashedarr;
  selected: array[1..maxarts] of boolean;
  highestart: word;
  highestread: word;
  wafenv: string;
  spooldir,temporarydir,userdir,waffledir,outboxdir: string;
  uucpname,node,smarthost,organ,timezone: string;
  newsname: string;
  netmail: string;
  netnews: string;
  replyto: string;
  home: string;
  joinfn,killfn,antikillfn: string;
  joinf,killf,antikillf: text;
  optfn: string;
  alreadyread: word;
  currgroup: string;
  headerinmem: string;
  headerbuf: headerbuft;
  headertrackedlines: headertrackedlinest;
  headerbytesinmem: integer;
  currart: integer;
  donegroup: boolean;
  browsedir: integer;
  browseonlysel: boolean;
  alreadyingroup: boolean;
  readallarts: boolean;
  readpagesback: integer;
  nextwhilereading: boolean;
  editor: string;
  editoroptions: string;
  vspeller: string;
  vspelleroptions: string;
  killsubjsp,killfromsp: killsarrp;
  killtextp: killsarrp;
  antikillsubjsp,antikillfromsp: killsarrp;
  antikilltextp: killsarrp;
  haskillfile: boolean;
  hasantikillfile: boolean;
  killfileinmem: boolean;
  antikillfileinmem: boolean;
  numkills: integer;
  numantikills: integer;
  numsubjks,numfromks: integer;
  numsubjaks,numfromaks: integer;
  nonglobalkills: boolean;
  nonglobalantikills: boolean;
  fullname: string;
  waffleversion: string;
  console: boolean;
  port: integer;
  trusted: boolean;
  minutes: integer;
  forumsetl: string;
  minstart: integer;
  mailfrom: string;
  newsfrom: string;
  lpp: integer;
  sellpp: integer;
  cols: integer;
  lowcolor: byte;
  highcolor: byte;
  oldtextattr: byte;
  lastfilen: string;
  browsemap: array[char] of char;
  selmap: array[char] of char;
  mainmap: array[char] of char;

{$ifdef mouse}
  hasmouse: boolean;
  mousevent: mevent;
  themouse: resetrec;
{$endif}

{ from here are are configuration variables }

  subjectscaseinsensitive: boolean;
  subjectlength: byte;
  makespacelikex: boolean;
  hideheaders: string;
  showheaders: string;
  highlightheaders: string;
  wanderingnumbers: boolean;
  antikillreferences: boolean;
  showsubjectkills: boolean;
  showfromkills: boolean;
  showsubjectantikills: boolean;
  showfromantikills: boolean;
  autoantikill: boolean;
  warnautoantikill: boolean;
  editaftervspell: boolean;
  caseinsensitivekill: boolean;
  caseinsensitiveantikill: boolean;
  substringsubjectkill: boolean;
  substringfromkill: boolean;
  substringsubjectantikill: boolean;
  substringfromantikill: boolean;
  quiet: boolean;
  ignoreenvironment: boolean;
  confirmnext: boolean;
  confirmquit: boolean;
  missingsubjectisok: boolean;
  tildehome: boolean;
  antikillthisnewsreader: boolean;  {not of great use to many, I'm sure}
  clearscreenbetweengroups: boolean;
  detectvideo: boolean;
  antikillevenkilled: boolean;
  mailprefix: string;
  ignoremouse: boolean;
  usebiosforscreen: boolean;
  hideformfeeds: boolean;
  pathuserid: string;
  customstatic: string;
  haltonunknowngroups: boolean;
  mousecharsheader: string;
  justdots: boolean;
  nofilemode: boolean;
{$ifdef uupc}
  uupcmode: boolean;
{$endif}

implementation

end.
